//
//  ViewController.m
//  USBClientApp
//
//  Copyright (C) 2021 WCH.
//  Created by WCH TECH<tech@wch.cn> on 2021/9/17.
//

#import "ViewController.h"
#import "CH37xLib.h"
#import <stdlib.h>
#import <IOKit/usb/USB.h>

#define readSize 4 * 1024 * 1024

@interface ViewController() <CH37xLibDelegate>

@property(nonatomic, strong)CH37xLib *client;

@property (weak) IBOutlet NSPopUpButton *devicePopUpButton;

@property (weak) IBOutlet NSTextField *deviceInfoTextField;

@property (weak) IBOutlet NSTextField *deviceStatusTextField;

@property (weak) IBOutlet NSButton *openCloseButton;

@property (weak) IBOutlet NSTextField *versionTextField;

@property (weak) IBOutlet NSPopUpButton *upPopUpButton;
@property (weak) IBOutlet NSPopUpButton *upPopUpButton1;
@property (weak) IBOutlet NSPopUpButton *upPopUpButton2;

@property (weak) IBOutlet NSPopUpButton *downPopUpButton;
@property (weak) IBOutlet NSPopUpButton *downPopUpButton1;

@property (weak) IBOutlet NSTextField *readSpeedTextField;
@property (weak) IBOutlet NSTextField *readSpeedTextField1;

@property (weak) IBOutlet NSTextField *readCountTextFiled;
@property (weak) IBOutlet NSTextField *readCountTextFiled1;

@property (weak) IBOutlet NSTextField *writeSpeedTextFiled;
@property (weak) IBOutlet NSTextField *writeSpeedTextFiled1;

@property (weak) IBOutlet NSTextField *writeCountTextField;
@property (weak) IBOutlet NSTextField *writeCountTextField1;

@property (weak) IBOutlet NSTextField *upCountText;
@property (weak) IBOutlet NSTextField *downCountText;


@property (nonatomic, strong) NSMutableData *writeData;
@property (nonatomic, strong) NSMutableDictionary *dataDic;
@property (nonatomic, strong) NSMutableDictionary *pageDic;

@property (nonatomic) BOOL shouldRead;

@property (nonatomic, assign) BOOL isOpen;
@property (nonatomic, assign) BOOL isRead;
@property (nonatomic, assign) BOOL isRead1;
@property (nonatomic, assign) BOOL isRead2;
@property (nonatomic, assign) BOOL isWrite;
@property (nonatomic, assign) BOOL isWrite1;

@property (nonatomic, strong) NSString *locationID;

@end

@implementation ViewController

- (void)dealloc {
    NSLog(@"Deallocing AnotherViewController %@", self);
}


- (void)viewDidLoad {
    [super viewDidLoad];
    
    // Do any additional setup after loading the view.
    self.isOpen = NO;
    self.isRead = NO;
    self.isRead1 = NO;
    self.isWrite = NO;
    self.isWrite1 = NO;
//    self.packageNum = -1;
    
    self.pageDic = [NSMutableDictionary dictionary];
    self.dataDic = [NSMutableDictionary dictionary];
    self.client = [[CH37xLib alloc] init];
    self.client.delegate = self;
//    NSURL *filePath = [[NSBundle mainBundle] URLForResource:@"ouput_user" withExtension:@"bin"];
    NSURL *filePath = [[NSBundle mainBundle] URLForResource:@"usb" withExtension:@"pdf"];
    NSData *data = [[NSData alloc] initWithContentsOfURL:filePath];
//    NSString* str = @"0123456789";
//    NSData *data = [str dataUsingEncoding:NSUTF8StringEncoding];
    
    if (nil == self.writeData) {
        self.writeData = [NSMutableData data];
    }
    
    
    [self.writeData appendData:data];
//    [self.writeData appendData:data];
//    [self.writeData appendData:data];
    
    NSInteger deviceCount = 0;
    
    deviceCount = [self.client CH37xScanDevices];
    NSLog(@"发现设备数量：%ld", (long)deviceCount);
    
//    for (int i = 0; i < self.deviceCount; i++) {
//        NSString *item = [[NSString alloc] initWithFormat:@"%d", i + 1];
//        [self.devicePopUpButton addItemWithTitle:item];
//    }
    
    NSArray *devices = [self.client CH37xGetAllDevices];
    
    for (int i = 0; i < devices.count; i++) {
        NSString *service = [devices objectAtIndex:i];
        NSString *item = [[NSString alloc] initWithFormat:@"0x%8x", [[self.client CH37xGetLocationID:service] intValue]];
        [self.devicePopUpButton addItemWithTitle:item];
    }
    
}


- (IBAction)scanDevices:(id)sender {
    
    [self.devicePopUpButton removeAllItems];
    NSInteger deviceCount = 0;
    deviceCount = [self.client CH37xScanDevices];
    if (deviceCount == 0) {
        self.deviceStatusTextField.stringValue = @"没有查找到可用设备";
    }else {
        self.deviceStatusTextField.stringValue = [[NSString alloc] initWithFormat:@"找到了%ld个设备，等待连接", deviceCount];
    }

    
    NSArray *devices = [self.client CH37xGetAllDevices];
    
    for (int i = 0; i < devices.count; i++) {
        NSString *service = [devices objectAtIndex:i];
        NSString *item = [[NSString alloc] initWithFormat:@"0x%8x", [[self.client CH37xGetLocationID:service] intValue]];
        [self.devicePopUpButton addItemWithTitle:item];
    }
}


- (void)CH37xDeviceConnect:(NSString *)locationID {
    NSString *item = [[NSString alloc] initWithFormat:@"0x%8x", [locationID intValue]];
    [self.devicePopUpButton addItemWithTitle:item];
}

- (void)CH37xDeviceDisConnect:(NSString *)locationID {
    NSString *item = [[NSString alloc] initWithFormat:@"0x%8x", [locationID intValue]];

    [self.devicePopUpButton removeItemWithTitle:item];
    
    if ([item isEqualToString:self.locationID] && self.isOpen) {
        self.isOpen = NO;
        NSString *title = self.isOpen ? @"断开设备" : @"连接设备";
        self.openCloseButton.title = title;
        self.deviceStatusTextField.stringValue = [[NSString alloc] initWithFormat:@"检测到%@设备断开连接", item];
        [self.devicePopUpButton setEnabled:YES];
        self.isRead = NO;
        self.isRead1 = NO;
        self.isWrite = NO;
        self.isWrite1 = NO;
    }

}

- (IBAction)openDeivce:(id)sender {
    
    if (self.devicePopUpButton.itemTitles.count == 0) {
        self.deviceStatusTextField.stringValue = @"未发现到设备请进行扫描";
        return;
    }
    
    IOReturn ret;
    NSInteger index = self.devicePopUpButton.indexOfSelectedItem;
    if (!self.isOpen) {
        self.locationID = [self.devicePopUpButton itemTitleAtIndex:index];
        ret = [self.client CH37xOpenDevice:index];
        if (ret == kIOReturnSuccess) {
            self.deviceStatusTextField.stringValue = [[NSString alloc] initWithFormat:@"%@设备打开成功", self.locationID];
            //获取驱动版本
            [self getDriverVersion:index];
            //获取设备ID
            [self getDeviceID:index];
            //获取设备描述
            [self getDeviceDesc:index];
            //获取上传端点
            [self getBlukInEndPoint:index];
            //获取下传端点
            [self getBlukOutEndPoint:index];
            //获取中断端点
            [self getInterruptEndPoint:index];
            //设置上下传缓冲区
            [self setBufUp:index];
            [self setBufDown:index];
            
            [self.devicePopUpButton setEnabled:NO];
        }
    }else {
        
        self.isRead = NO;
        self.isRead1 = NO;
        self.isWrite = NO;
        self.isWrite1 = NO;
        
        ret = [self.client CH37xCloseDevice:index];
        if (ret == kIOReturnSuccess) {
            self.deviceStatusTextField.stringValue = [[NSString alloc] initWithFormat:@"%@设备关闭成功", self.locationID];
        }
        self.locationID = @"";
        [self.devicePopUpButton setEnabled:YES];
    }
    self.isOpen = !self.isOpen;
    NSString *title = self.isOpen ? @"断开设备" : @"连接设备";
    self.openCloseButton.title = title;

}

- (IBAction)readIntteruptAction:(id)sender {
    if (!self.isOpen || self.isRead2) {
        return;
    }
    
//    __block NSInteger count = 3;
    
    NSString *titleOfSelectedItem = self.upPopUpButton2.titleOfSelectedItem;
    NSInteger index = self.devicePopUpButton.indexOfSelectedItem;
    
    if (titleOfSelectedItem == nil) {
        return;
    }
    
    //16进制字符串转10进制
    const char *hexstring = [titleOfSelectedItem cStringUsingEncoding:[NSString defaultCStringEncoding]];;
    uint8_t endpointAddress = (uint8_t)strtol(hexstring, NULL, 16);
    IOUSBEndpointDescriptor descriptor = [self getEndpointAttributes:index bEndpointAddress:endpointAddress];
    
    __weak typeof(self) wself = self;
    dispatch_queue_t pollQueue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
    wself.isRead2 = YES;
    
    dispatch_async(pollQueue, ^{
        
        NSTimeInterval startTime = [[NSDate date] timeIntervalSince1970];
        NSInteger dataCount = 0;
        double speed = 0;

        while (wself.isRead2) {
            NSData *data = [wself interruptData:index bEndpointAddress:descriptor.bEndpointAddress];
            dataCount += data.length;
            NSTimeInterval currentTime = [[NSDate date] timeIntervalSince1970];
            NSTimeInterval diffTime = currentTime - startTime;
            speed = (dataCount / diffTime) / 1024 / 1024;
            NSString *speedStr = [[NSString alloc] initWithFormat:@"%0.2f M/S", speed];
            dispatch_async(dispatch_get_main_queue(), ^{
                wself.readSpeedTextField.stringValue = speedStr;
                wself.readCountTextFiled.stringValue = [[NSString alloc] initWithFormat:@"%ld", (long)dataCount];
            });
        }
    });
}

- (IBAction)stopInterruptAction:(id)sender {
    self.isRead2 = NO;
    if (!self.isOpen) {
        return;
    }
}


- (IBAction)uploadAction:(id)sender {
    
    if (!self.isOpen || self.isRead) {
        return;
    }

    NSString *titleOfSelectedItem = self.upPopUpButton.titleOfSelectedItem;
    NSInteger index = self.devicePopUpButton.indexOfSelectedItem;
    
    //16进制字符串转10进制
    const char *hexstring = [titleOfSelectedItem cStringUsingEncoding:[NSString defaultCStringEncoding]];;
    uint8_t endpointAddress = (uint8_t)strtol(hexstring, NULL, 16);
    IOUSBEndpointDescriptor descriptor = [self getEndpointAttributes:index bEndpointAddress:endpointAddress];
    
    NSString *key = [[NSString alloc] initWithFormat:@"%d", descriptor.bEndpointAddress];
    NSString *pageStr = @"-1";
    [self.pageDic setObject:pageStr forKey:key];
    
    NSData *data = [NSData data];
    [self.dataDic setObject:data forKey:key];
    
    __weak typeof(self) wself = self;
    dispatch_queue_t pollQueue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
    wself.isRead = YES;
    
    [self startReadIO:index bEndpointAddress:descriptor.bEndpointAddress];
    dispatch_time_t delayTime = dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.5 * NSEC_PER_SEC));

//        延时一秒后开始读取buffer
    dispatch_after(delayTime, dispatch_get_main_queue(), ^{
        //开启一个异步线程在buffer中读取数据
        dispatch_async(pollQueue, ^{
            
            NSTimeInterval startTime = 0;
            uint64_t dataCount = 0;
            NSInteger otherCount = 0;
            double speed = 0;
            
            while (self.isRead) {
               
                NSInteger queusize = [self getQueueSize:index bEndpointAddress:descriptor.bEndpointAddress];
                
                if (otherCount == 0) {
                    startTime = [[NSDate date] timeIntervalSince1970];
                }
                
                NSData *data = [wself readDataFromBuffer:index bEndpointAddress:descriptor.bEndpointAddress];
                if (data != nil) {
                    dataCount += data.length;
                    otherCount += data.length;
                   
                    if (otherCount >= 100 * 1024 * 1024) {
                        
                        NSTimeInterval currentTime = [[NSDate date] timeIntervalSince1970];
                        NSTimeInterval diffTime = currentTime - startTime;
                        speed = (otherCount / diffTime) / 1024 / 1024;
                        NSString *speedStr = [[NSString alloc] initWithFormat:@"%0.2f M/S", speed];
                        otherCount = 0;
                        
                        dispatch_async(dispatch_get_main_queue(), ^{
                            self.readSpeedTextField.stringValue = speedStr;
                        });
                    }
                    
                    dispatch_async(dispatch_get_main_queue(), ^{
                        self.upCountText.stringValue = [[NSString alloc] initWithFormat:@"%ld", (long)queusize];
                        self.readCountTextFiled.stringValue = [[NSString alloc] initWithFormat:@"%ld", (long)dataCount];
                    });
         
                }
            }
        });
    });
}

- (IBAction)uploadAction1:(id)sender {
    if (!self.isOpen || self.isRead1) {
        return;
    }
    
    NSString *titleOfSelectedItem = self.upPopUpButton1.titleOfSelectedItem;
    NSInteger index = self.devicePopUpButton.indexOfSelectedItem;
    
    //16进制字符串转10进制
    const char *hexstring = [titleOfSelectedItem cStringUsingEncoding:[NSString defaultCStringEncoding]];;
    uint8_t endpointAddress = (uint8_t)strtol(hexstring, NULL, 16);
    IOUSBEndpointDescriptor descriptor = [self getEndpointAttributes:index bEndpointAddress:endpointAddress];
    
    NSString *key = [[NSString alloc] initWithFormat:@"%d", descriptor.bEndpointAddress];
    NSString *pageStr = @"-1";
    [self.pageDic setObject:pageStr forKey:key];
    
    NSData *data = [NSData data];
    [self.dataDic setObject:data forKey:key];
    
    __weak typeof(self) wself = self;
    dispatch_queue_t pollQueue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
    
    self.isRead1 = YES;
    
    dispatch_async(pollQueue, ^{
        
        NSTimeInterval startTime = 0;
        NSInteger dataCount = 0;
        NSInteger otherCount = 0;
        double speed = 0;
        
        while (wself.isRead1) {
            if (otherCount == 0) {
                startTime = [[NSDate date] timeIntervalSince1970];
            }
            NSData *data = [wself readData:index bEndpointAddress:descriptor.bEndpointAddress];
            if (data != nil) {
                dataCount += data.length;
                otherCount += data.length;
                
                if (otherCount >= 100 * 1024 * 1024) {
                    
                    NSTimeInterval currentTime = [[NSDate date] timeIntervalSince1970];
                    NSTimeInterval diffTime = currentTime - startTime;
                    speed = (otherCount / diffTime) / 1024 / 1024;
                    NSString *speedStr = [[NSString alloc] initWithFormat:@"%0.2f M/S", speed];
                    otherCount = 0;
                    
                    dispatch_async(dispatch_get_main_queue(), ^{
                        wself.readSpeedTextField1.stringValue = speedStr;
                    });
                }
                

                dispatch_async(dispatch_get_main_queue(), ^{
                    wself.readCountTextFiled1.stringValue = [[NSString alloc] initWithFormat:@"%ld", (long)dataCount];
                });
            }
        }
    });
}


- (IBAction)stopUploadAction:(id)sender {
    self.isRead = NO;
    if (!self.isOpen) {
        return;
    }

    NSString *titleOfSelectedItem = self.upPopUpButton.titleOfSelectedItem;
    NSInteger index = self.devicePopUpButton.indexOfSelectedItem;
    //16进制字符串转10进制
    const char *hexstring = [titleOfSelectedItem cStringUsingEncoding:[NSString defaultCStringEncoding]];;
    uint8_t endpointAddress = (uint8_t)strtol(hexstring, NULL, 16);

    IOUSBEndpointDescriptor descriptor = [self getEndpointAttributes:index bEndpointAddress:endpointAddress];
    [self stopReadIO:index bEndpointAddress:descriptor.bEndpointAddress];
}

- (IBAction)stopUploadAction1:(id)sender {
    self.isRead1 = NO;
}


- (IBAction)downAction:(id)sender {
    
    if (!self.isOpen || self.isWrite) {
        return;
    }

    self.isWrite = YES;
    
    NSString *titleOfSelectedItem = self.downPopUpButton.titleOfSelectedItem;
    NSInteger index = self.devicePopUpButton.indexOfSelectedItem;

    //16进制字符串转10进制
    const char *hexstring = [titleOfSelectedItem cStringUsingEncoding:[NSString defaultCStringEncoding]];;
    uint8_t endpointAddress = (uint8_t)strtol(hexstring, NULL, 16);
    IOUSBEndpointDescriptor descriptor = [self getEndpointAttributes:index bEndpointAddress:endpointAddress];
    
    [self ResetWrite:index bEndpointAddress:descriptor.bEndpointAddress];
    
    __weak typeof(self) wself = self;
    dispatch_queue_t pollQueue = dispatch_queue_create("cn.wch.write", 0);
//    dispatch_queue_t pollQueue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
    
    dispatch_async(pollQueue, ^{
        
        NSTimeInterval startTime = 0;
        NSTimeInterval diffTime = 0;
        NSInteger dataCount = 0;
        NSInteger otherCount = 0;
        double speed = 0;
//        NSInteger totalCount = 0;
        
        while (self.isWrite) {
            
//            if (totalCount > 10000) {
//                self.isWrite = false;
//                break;
//            }
//            totalCount++;
            
            if (otherCount == 0) {
                startTime = [[NSDate date] timeIntervalSince1970];
            }
            
            NSInteger queusize = [self getQueueSize:index bEndpointAddress:descriptor.bEndpointAddress];
            NSInteger count = [wself asyncWriteData:index bEndpointAddress:descriptor.bEndpointAddress];
            if (count > 0) {
                dataCount += count;
                otherCount += count;
                
                NSTimeInterval currentTime = [[NSDate date] timeIntervalSince1970];
                diffTime = currentTime - startTime;
                
                if (diffTime > 1) {
                    speed = (otherCount / diffTime) / 1024 / 1024;
                    NSString *speedStr = [[NSString alloc] initWithFormat:@"%0.2f M/S", speed];
                    otherCount = 0;
                    
                    dispatch_async(dispatch_get_main_queue(), ^{
                        wself.writeSpeedTextFiled.stringValue = speedStr;
                    });
                }
                
                dispatch_async(dispatch_get_main_queue(), ^{
                    wself.downCountText.stringValue = [[NSString alloc] initWithFormat:@"%ld", (long)queusize];
                    wself.writeCountTextField.stringValue = [[NSString alloc] initWithFormat:@"%ld", (long)dataCount];
                });
            }

        }
    });

}
- (IBAction)downloadAction1:(id)sender {
    if (!self.isOpen || self.isWrite1) {
        return;
    }

    self.isWrite1 = YES;
    
    NSString *titleOfSelectedItem = self.downPopUpButton1.titleOfSelectedItem;
    NSInteger index = self.devicePopUpButton.indexOfSelectedItem;

    //16进制字符串转10进制
    const char *hexstring = [titleOfSelectedItem cStringUsingEncoding:[NSString defaultCStringEncoding]];;
    uint8_t endpointAddress = (uint8_t)strtol(hexstring, NULL, 16);
    IOUSBEndpointDescriptor descriptor = [self getEndpointAttributes:index bEndpointAddress:endpointAddress];
    
    __weak typeof(self) wself = self;
    dispatch_queue_t pollQueue = dispatch_queue_create("cn.wch.write", 0);
//    dispatch_queue_t pollQueue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
    
    dispatch_async(pollQueue, ^{

        NSTimeInterval startTime = 0;
        NSTimeInterval diffTime = 0;
        NSInteger dataCount = 0;
        NSInteger otherCount = 0;
        double speed = 0;
        while (self.isWrite1) {
            if (otherCount == 0) {
                startTime = [[NSDate date] timeIntervalSince1970];
            }
            NSInteger count = [wself writeData:index bEndpointAddress:descriptor.bEndpointAddress];
            if (count > 0) {
                dataCount += count;
                otherCount += count;
                
                NSTimeInterval currentTime = [[NSDate date] timeIntervalSince1970];
                diffTime = currentTime - startTime;
                if (diffTime > 1) {
                    speed = (otherCount / diffTime) / 1024 / 1024;
                    NSString *speedStr = [[NSString alloc] initWithFormat:@"%0.2f M/S", speed];
                    otherCount = 0;
                    
                    dispatch_async(dispatch_get_main_queue(), ^{
                        wself.writeSpeedTextFiled1.stringValue = speedStr;
                    });
                }
            
                dispatch_async(dispatch_get_main_queue(), ^{
                    wself.writeCountTextField1.stringValue = [[NSString alloc] initWithFormat:@"%ld", (long)dataCount];
                });
            }

        }
    });
}

- (IBAction)stopDownAction:(id)sender {
    self.isWrite = NO;
    NSInteger size = 0;
    
    NSString *titleOfSelectedItem = self.downPopUpButton.titleOfSelectedItem;
    NSInteger index = self.devicePopUpButton.indexOfSelectedItem;

    //16进制字符串转10进制
    const char *hexstring = [titleOfSelectedItem cStringUsingEncoding:[NSString defaultCStringEncoding]];;
    uint8_t endpointAddress = (uint8_t)strtol(hexstring, NULL, 16);
    IOUSBEndpointDescriptor descriptor = [self getEndpointAttributes:index bEndpointAddress:endpointAddress];
    
    size = [self getQueueSize:index bEndpointAddress:descriptor.bEndpointAddress];
    while (size != 0) {
        size = [self getQueueSize:index bEndpointAddress:descriptor.bEndpointAddress];
        [self ResetWrite:index bEndpointAddress:descriptor.bEndpointAddress];
    }
    
    dispatch_async(dispatch_get_main_queue(), ^{
        NSLog(@"%ld",(long)size);
        self.downCountText.stringValue = [[NSString alloc] initWithFormat:@"%ld", (long)size];
    });
    
   
}

- (IBAction)stopDownAction1:(id)sender {
    self.isWrite1 = NO;
}

- (void)getDriverVersion:(NSInteger)index {
    
    uint8_t *memO;
    size_t outputSize;
    outputSize = 64;
    
    memO = (uint8_t *)malloc(outputSize);
    [self.client CH37xGetVersion:index buffer:memO size:outputSize];
    
    self.versionTextField.stringValue = [[NSString alloc] initWithFormat:@"%s", memO];
    
}

- (void)getDeviceID:(NSInteger)index {
    IOReturn ret;
    uint64_t deviceInfo[] = {};
    ret = [self.client CH37xGetDeviceID:index buffer:deviceInfo size:2];
    if (ret == kIOReturnSuccess) {
        self.deviceInfoTextField.stringValue = [[NSString alloc] initWithFormat:@"PID:%llu VID:%llu", deviceInfo[0], deviceInfo[1]];
    }
}

- (void)getDeviceDesc:(NSInteger)index {
    IOReturn ret;
    uint64_t deviceInfo[12] = {};
    ret = [self.client CH37xGetDeviceDesc:index buffer:deviceInfo];
    if (ret == kIOReturnSuccess) {
        struct IOUSBDeviceDescriptor descriptor;
        descriptor.bLength = deviceInfo[0];
        descriptor.bDescriptorType = deviceInfo[1];
        descriptor.bcdUSB = deviceInfo[2];
        descriptor.bDeviceClass = deviceInfo[3];
        descriptor.bDeviceSubClass = deviceInfo[4];
        descriptor.bDeviceProtocol = deviceInfo[5];
        descriptor.bMaxPacketSize0 = deviceInfo[6];
        descriptor.bcdDevice = deviceInfo[7];
        descriptor.iManufacturer = deviceInfo[8];
        descriptor.iProduct = deviceInfo[9];
        descriptor.iSerialNumber = deviceInfo[10];
        descriptor.bNumConfigurations = deviceInfo[11];
    }
}

//获取上传端点
- (void)getBlukInEndPoint:(NSInteger)index {
    [self.upPopUpButton removeAllItems];
    [self.upPopUpButton1 removeAllItems];
    NSArray *endpoints = [self.client CH37xGetBulkInEndPoint:index];
    [endpoints enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {

        struct IOUSBEndpointDescriptor descriptor;
        NSValue *customValue = obj;
        [customValue getValue:&descriptor];
        
        NSString *item = [[NSString alloc] initWithFormat:@"0x%02x", descriptor.bEndpointAddress];
        [self.upPopUpButton addItemWithTitle:item];
        [self.upPopUpButton1 addItemWithTitle:item];
    }];
    
}

//获取下传端点
- (void)getBlukOutEndPoint:(NSInteger)index {
    [self.downPopUpButton removeAllItems];
    [self.downPopUpButton1 removeAllItems];
    NSArray *endpoints = [self.client CH37xGetBulkOutEndPoint:index];
    [endpoints enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {

        struct IOUSBEndpointDescriptor descriptor;
        NSValue *customValue = obj;
        [customValue getValue:&descriptor];
        NSString *item = [[NSString alloc] initWithFormat:@"0x%02x", descriptor.bEndpointAddress];
        [self.downPopUpButton addItemWithTitle:item];
        [self.downPopUpButton1 addItemWithTitle:item];
    }];
}

- (void)getInterruptEndPoint:(NSInteger)index {
    [self.upPopUpButton2 removeAllItems];
    NSArray *endpoints = [self.client CH37xGetInterrputEndPoint:index];
    [endpoints enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {

        struct IOUSBEndpointDescriptor descriptor;
        NSValue *customValue = obj;
        [customValue getValue:&descriptor];
        NSString *item = [[NSString alloc] initWithFormat:@"0x%02x", descriptor.bEndpointAddress];
        [self.upPopUpButton2 addItemWithTitle:item];
    }];
}

//获取端点属性
- (IOUSBEndpointDescriptor)getEndpointAttributes:(NSInteger)index bEndpointAddress:(uint8_t)bEndpointAddress {
    
    NSArray *endpoints = [self.client CH37xGetDeviceMsg:index];
    NSInteger count = endpoints.count;
    
    struct IOUSBEndpointDescriptor descriptor = {};
    for (int i = 0; i < count; i++) {
       
        NSValue *customValue = endpoints[i];
        [customValue getValue:&descriptor];
        
        if (descriptor.bEndpointAddress == bEndpointAddress) {
            return descriptor;
        }
    }
    return descriptor;
}

- (void)startReadIO:(NSInteger)index bEndpointAddress:(uint8_t)bEndpointAddress   {
    IOReturn ret;
  
    ret = [self.client CH37xStartBufUpload:index bEndpointAddress:bEndpointAddress packageSize:readSize];
    if (ret == kIOReturnSuccess) {
        NSLog(@"开启IO读取");
    }else if (ret == kIOReturnOverrun) {
        NSLog(@"缓冲区溢出了");
    }
    NSString *key = [[NSString alloc] initWithFormat:@"%d", bEndpointAddress];
    
    if (self.dataDic.count == 0) {
        NSString *pageStr = @"-1";
        [self.pageDic setObject:pageStr forKey:key];
    }
    
    if (self.dataDic.count == 0) {
        NSData *data = [NSData data];
        [self.dataDic setObject:data forKey:key];
    }
}

- (void)stopReadIO:(NSInteger)index bEndpointAddress:(uint8_t)bEndpointAddress   {
    IOReturn ret;
    
    ret = [self.client CH37xStopBufUpload:index bEndpointAddress:bEndpointAddress];
    if (ret == kIOReturnSuccess) {
        NSLog(@"关闭IO读取");
    }
}

- (NSData *)readDataFromBuffer:(NSInteger)index bEndpointAddress:(uint8_t)bEndpointAddress   {

    IOReturn ret;
    uint8_t *memO;
    size_t outputSize;
    outputSize = readSize;
    memO = (uint8_t *)malloc(outputSize);
    
    ret =  [self.client CH37xReadEndP:index bEndpointAddress:bEndpointAddress buffer:memO size:outputSize];
    if (ret == kIOReturnSuccess) {
        NSData *data = [NSData dataWithBytes:memO length:outputSize];
        if (data != nil && data.length > 0) {
//            [self compareReadData:data bEndpointAddress:bEndpointAddress];
        }
        free(memO);
        return data;
    }
    
    free(memO);
    return nil;
  
}

- (BOOL)compareReadData:(NSData *)data bEndpointAddress:(uint8_t)bEndpointAddress{
    
    if (data.length == 0) {
        return false;
    }
    
    NSMutableArray *dataArray = [NSMutableArray array];
    [dataArray removeAllObjects];
    
    NSString *key = [[NSString alloc] initWithFormat:@"%d", bEndpointAddress];
    NSData *currentData = [self.dataDic objectForKey:key];
    NSString *number = [self.pageDic objectForKey:key];
    NSInteger packageNum = [number intValue];
    
    NSUInteger length = [data length];
    NSUInteger chunkSize =  1024;
    NSUInteger offset = 0;
    do {
        NSUInteger thisChunkSize = length - offset > chunkSize ? chunkSize : length - offset;
        NSData *chunk = [data subdataWithRange:NSMakeRange(offset, chunkSize)];
        offset += thisChunkSize;
        // do something with chunk
        [dataArray addObject:chunk];

    } while (offset < length);
//
    if (currentData.length == 0 && dataArray.count > 0) {
        currentData = dataArray[0];
    }

    NSData *data1 = currentData;
    NSData *data2 = nil;

    for (int i = 0; i < dataArray.count; i++) {

        data1 = currentData;

        if (packageNum == -1) {
            data2 = dataArray[i + 1];
        }else {
            data2 = dataArray[i];
        }

        NSInteger number1 = [self getPackageNum:data1];
        NSInteger number2 = [self getPackageNum:data2];

        NSData *prevData = [self getPackateContent:data1];
        NSData *nextData = [self getPackateContent:data2];

        BOOL flag = [prevData isEqualToData:nextData];

        if (!flag || (number2 - 1 != number1)) {
            NSLog(@"数据不相等");
            return NO;
        }

        if (packageNum == -1) {
            currentData = data1;
            packageNum = number1;

        }else {
            currentData = data2;
            packageNum = number2;
        }
    }
    
    [self.dataDic setObject:currentData forKey:key];
    [self.pageDic setObject:[[NSString alloc] initWithFormat:@"%ld", (long)packageNum] forKey:key];
    
  
    return YES;
}

- (NSInteger)getPackageNum:(NSData *)data {
    UInt64 value = 0;
    NSData *intData = [data subdataWithRange:NSMakeRange(0, 4)];
    @autoreleasepool {
        value = CFSwapInt32BigToHost(*(int *)([intData bytes]));
        return value;
    }
   
}

- (NSData *)getPackateContent:(NSData *)data {
    if (data.length != 1024) {
        NSLog(@"错误的数据长度");
    }
    NSData *rData = [data subdataWithRange:NSMakeRange(4, data.length - 4)];
//    NSLog(@"%@", rData);
    return rData;
}


- (NSInteger)writeData:(NSInteger)index bEndpointAddress:(uint8_t)bEndpointAddress   {
    IOReturn ret;
    Byte *byte = (unsigned char *)[self.writeData bytes];
    ret = [self.client CH37xSyncWriteData:index bEndpointAddress:bEndpointAddress buffer:byte size:self.writeData.length];
    if (ret != kIOReturnSuccess) {
        return -1;
    }
    return self.writeData.length;
}

- (NSInteger)asyncWriteData:(NSInteger)index bEndpointAddress:(uint8_t)bEndpointAddress {
    IOReturn ret;
    Byte *byte = (unsigned char *)[self.writeData bytes];

    ret = [self.client CH37xStartBufDownload:index bEndpointAddress:bEndpointAddress buffer:byte size:self.writeData.length needRead:self.shouldRead];
    
    if (ret != kIOReturnSuccess) {
        return -1;
    }
    
    return self.writeData.length;
}

- (BOOL)ResetWrite:(NSInteger)index bEndpointAddress:(uint8_t)bEndpointAddress {
    IOReturn ret;
    ret = [self.client CH37xResetWrite:index bEndpointAddress:bEndpointAddress];
    if (ret != kIOReturnSuccess) {
        return NO;
    }
    
    return YES;
}

- (BOOL)setBufUp:(NSInteger)index {
    IOReturn ret;
    size_t size = 100 * 1024 * 1024;
    ret = [self.client CH37xSetBufUpload:index bufferSize:size];
    if (ret != kIOReturnSuccess) {
        return NO;
    }
    
    return YES;
}

- (BOOL)setBufDown:(NSInteger)index {
    IOReturn ret;
    size_t size = 50 * 1024 * 1024;
    ret = [self.client CH37xSetBufDownload:index bufferSize:size];
    if (ret != kIOReturnSuccess) {
        return NO;
    }
    
    return YES;
}


- (NSData *)interruptData:(NSInteger)index bEndpointAddress:(uint8_t)bEndpointAddress {
    uint8_t *memO;
    size_t outputSize;
    IOReturn ret;
    
    outputSize = readSize;
    memO = (uint8_t *)malloc(outputSize);
    
    ret = [self.client CH37xInterruptRead:index bEndpointAddress:bEndpointAddress buffer:memO size:outputSize];
    if (ret == kIOReturnSuccess) {
        NSData *data = [[NSData alloc] initWithBytes:memO length:outputSize];
        free(memO);
        return data;
    }
    free(memO);
    return nil;
}

- (NSData *)readData:(NSInteger)index bEndpointAddress:(uint8_t)bEndpointAddress   {
    
    uint8_t *memO;
    size_t size;
    IOReturn ret;
    
    size = readSize;
    memO = (uint8_t *)malloc(size);
    
    ret = [self.client CH37xSyncReadData:index bEndpointAddress:bEndpointAddress buffer:memO size:size];
    if (ret == kIOReturnSuccess) {
        NSMutableData *data1 = [NSMutableData data];
        size_t part = size / 1024;
        size_t remain = size % 1024;
        for (int i = 0; i < part; i++) {
            NSData *sp = [[NSData alloc] initWithBytes:memO + i * 1024 length:1024];
            [data1 appendData:sp];
        }
    
        if (remain > 0) {
            NSData *sp = [[NSData alloc] initWithBytes:memO + part * 1024 length:remain];
            [data1 appendData:sp];
        }
//        [self compareReadData:data1 bEndpointAddress:bEndpointAddress];
        
        free(memO);
        return data1;
    }
    
    free(memO);
    return nil;

}


- (NSInteger)getQueueSize:(NSInteger)index bEndpointAddress:(uint8_t)bEndpointAddress {
    return [self.client CH37xQueryBuf:index bEndpointAddress:bEndpointAddress];
}


- (NSString*)formatByteCount:(long long)size{
    return [NSByteCountFormatter stringFromByteCount:size countStyle:NSByteCountFormatterCountStyleBinary];
}

@end
